Package: org.codehaus.groovy.transform

## [Java] Class AbstractASTTransformation

- org.codehaus.groovy.transform.AbstractASTTransformation

- All Implemented Interfaces and Traits:
    ASTTransformation, org.objectweb.asm.Opcodes

      public abstract class AbstractASTTransformation
      extends Object

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static ClassNode` | `RETENTION_CLASSNODE` |
    `protected SourceUnit` | `sourceUnit` |

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `void` | `addError(String msg, ASTNode expr)`
    `` | `protected boolean` | `checkIncludeExclude(AnnotationNode node, List<String> excludes, List<String> includes, String typeName)`
    `` | `protected void` | `checkIncludeExclude(AnnotationNode node, List<String> excludes, List<String> includes, List<ClassNode> excludeTypes, List<ClassNode> includeTypes, String typeName)`
    `` | `protected boolean` | `checkNotInterface(ClassNode cNode, String annotationName)`
    `` | `protected List<AnnotationNode>` | `copyAnnotatedNodeAnnotations(AnnotatedNode annotatedNode, String myTypeName)` Copies all `candidateAnnotations` with retention policy RetentionPolicy.RUNTIME and RetentionPolicy.CLASS.
    `` | `static boolean` | `deemedInternalName(String name)`
    `` | `List<ClassNode>` | `getClassList(AnnotationNode anno, String name)`
    `` | `ClassNode` | `getMemberClassValue(AnnotationNode node, String name)`
    `` | `ClassNode` | `getMemberClassValue(AnnotationNode node, String name, ClassNode defaultValue)`
    `` | `int` | `getMemberIntValue(AnnotationNode node, String name)`
    `` | `static List<String>` | `getMemberList(AnnotationNode anno, String name)`
    `` | `static String` | `getMemberStringValue(AnnotationNode node, String name, String defaultValue)`
    `` | `static String` | `getMemberStringValue(AnnotationNode node, String name)`
    `` | `Object` | `getMemberValue(AnnotationNode node, String name)`
    `` | `boolean` | `hasAnnotation(ClassNode cNode, ClassNode annotation)`
    `` | `protected void` | `init(ASTNode[] nodes, SourceUnit sourceUnit)`
    `` | `boolean` | `memberHasValue(AnnotationNode node, String name, Object value)`
    `` | `static ClassNode` | `nonGeneric(ClassNode type)` @deprecated use GenericsUtils#nonGeneric
    `` | `static boolean` | `shouldSkip(String name, List<String> excludes, List<String> includes)`
    `` | `static boolean` | `shouldSkipOnDescriptor(boolean checkReturn, Map genericsSpec, MethodNode mNode, List<ClassNode> excludeTypes, List<ClassNode> includeTypes)`
    `` | `static List<String>` | `tokenize(String rawExcludes)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `equals, toString, hashCode, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### public static final ClassNode RETENTION_CLASSNODE

    - #### protected SourceUnit sourceUnit

  - ### Method Detail

    - #### public void addError(String msg, ASTNode expr)

    - #### protected boolean checkIncludeExclude(AnnotationNode node, List<String> excludes, List<String> includes, String typeName)

    - #### protected void checkIncludeExclude(AnnotationNode node, List<String> excludes, List<String> includes, List<ClassNode> excludeTypes, List<ClassNode> includeTypes, String typeName)

    - #### protected boolean checkNotInterface(ClassNode cNode, String annotationName)

    - #### protected List<AnnotationNode> copyAnnotatedNodeAnnotations(AnnotatedNode annotatedNode, String myTypeName)

      Copies all `candidateAnnotations` with retention policy RetentionPolicy.RUNTIME and RetentionPolicy.CLASS.

      Annotations with GeneratedClosure members are not supported for now.

    - #### public static boolean deemedInternalName(String name)

    - #### public List<ClassNode> getClassList(AnnotationNode anno, String name)

    - #### public ClassNode getMemberClassValue(AnnotationNode node, String name)

    - #### public ClassNode getMemberClassValue(AnnotationNode node, String name, ClassNode defaultValue)

    - #### public int getMemberIntValue(AnnotationNode node, String name)

    - #### public static List<String> getMemberList(AnnotationNode anno, String name)

    - #### public static String getMemberStringValue(AnnotationNode node, String name, String defaultValue)

    - #### public static String getMemberStringValue(AnnotationNode node, String name)

    - #### public Object getMemberValue(AnnotationNode node, String name)

    - #### public boolean hasAnnotation(ClassNode cNode, ClassNode annotation)

    - #### protected void init(ASTNode[] nodes, SourceUnit sourceUnit)

    - #### public boolean memberHasValue(AnnotationNode node, String name, Object value)

    - #### @Deprecated public static ClassNode nonGeneric(ClassNode type)

      deprecated:
        use GenericsUtils#nonGeneric

    - #### public static boolean shouldSkip(String name, List<String> excludes, List<String> includes)

    - #### public static boolean shouldSkipOnDescriptor(boolean checkReturn, Map genericsSpec, MethodNode mNode, List<ClassNode> excludeTypes, List<ClassNode> includeTypes)

    - #### public static List<String> tokenize(String rawExcludes)